/****************************************************************************************

		Measurement.cpp Fuctions for measurement
		
													2010.4.19 M.Utsumi@ArcDevice 

*****************************************************************************************/


#include<windows.h>
#include<stdio.h>
#include<conio.h>

double MES_dTimeScale;
double MES_dTime_ini;		/* Initial  time */
double MES_dTime_prv;		/* Previous time */
double MES_dTime_cur;		/* Current  time */
double MES_dTime_int;		/* Interval time */

void MES_StartTimeCount( void )
{
	LONGLONG freq;
	LONGLONG time_count;
	
	// N̂botNbÑJEgl猻݂̎vZB
	 
	// bot̃NbNg擾B
	if( !QueryPerformanceFrequency( (LARGE_INTEGER*)&freq ) ){
		printf("err");
		return;
	}
	MES_dTimeScale = 1.0 / freq;	// g1NbN̎vZB
	
	QueryPerformanceCounter( (LARGE_INTEGER*)&time_count ); // JEgl擾B
	MES_dTime_ini = time_count * MES_dTimeScale;						// JnԂƂċL^B
	MES_dTime_cur = 0;
	MES_dTime_prv = 0;
}

void MES_GetTimeCount( void  )
{
	LONGLONG time_count;

	QueryPerformanceCounter( (LARGE_INTEGER*)&time_count ); // JEgl擾B
	
	MES_dTime_cur = time_count * MES_dTimeScale - MES_dTime_ini; //@StartTimeCounť݂̎ԁioߎԁjvZ
	MES_dTime_int = MES_dTime_cur - MES_dTime_prv;	// 	O񂩂̌oߎԂvB	
	MES_dTime_prv = MES_dTime_cur;			// 	݂̎ԂۑB
}

void MES_WaitNextTime( double dNextTime )
{
	LONGLONG time_count;

	do{ // 	dNextTimebɂȂ܂ő҂B
		QueryPerformanceCounter( (LARGE_INTEGER*)&time_count );
		
		MES_dTime_cur = time_count * MES_dTimeScale - MES_dTime_ini;
	}while( MES_dTime_cur < dNextTime );
	
	MES_dTime_int = MES_dTime_cur - MES_dTime_prv;
	MES_dTime_prv = MES_dTime_cur;
}


BOOL MES_Save( char* pFileName, char* pCaption, void* pData, int nItem, int nSize )
{
	int i;
	FILE* fp;
	float* pfData;

	if( fopen_s( &fp, pFileName, "w+" ) != 0 ){
		printf( "t@CJ܂");
		return( FALSE );
	}

	fprintf( fp, "%s\n",pCaption );

	pfData = (float*)pData;

	for(i=0;i<nSize*nItem;i++){
		fprintf( fp,"%f",*pfData++ );
		if( (i+1)%nItem==0 ) fprintf( fp,"\n");
		else fprintf( fp,"," );
	}

	fclose( fp );
	return( TRUE );
};


void MES_PrintData( void* pData, int nSize )
{
	int i;
	unsigned char* buf;

	buf = (unsigned char*)pData;

	i=0;
	while(nSize--){
        printf( "%02x ", *buf++ );
		if(++i==16){
			printf("\r\n");
			i=0;
		}
	}
	printf("\r\n");
}
