/*****************************************************************************************************

	MCD05.h : class MCD05 Ver.2.1
	 
	
													2015.7.28 M.Utsumi@ARCDEVICE 

******************************************************************************************************/

#pragma once

#include<windows.h>
#include"ControlModule.h"

// R}h
#define MCD05_CLEAR_DATA	51
#define MCD05_EXCHANGE		150

typedef struct _MCD05_INPUT
{
	long lEncoder;
//	WORD wSensor[5];
} MCD05_INPUT;

typedef struct _MCD05_OUTPUT
{
	short sPwm;
} MCD05_OUTPUT;


class MCD05 : public ControlModule
{
public:
	MCD05();
	~MCD05();

	BOOL ClearData( void );
	BOOL Exchange( void* pOutputData, void* pInputData, BOOL RightNow=TRUE );
	BOOL Exchange( BOOL RightNow=TRUE );

	MCD05_INPUT InputData;
	MCD05_OUTPUT OutputData;

private:
	BOOL Receive( BYTE *pRxBuffer, WORD wSize );	
	
};


