/*****************************************************************************************************

	Main.cpp	SC02 + MCD05 Sample Program

	{Iȃf[^̑MsTvD
	AMCD05̑䐔ɍ킹MODULE_NUMύXDl1D
	MCD05ID0AԂŐݒ肵ĂD

	
													2015.7.22 M.Utsumi@ARCDEVICE

******************************************************************************************************/

#include<windows.h>
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<math.h>
#include"SC02.h"
#include"MCD05.h"
#include"Measurement.h"

#define MODULE_NUM	1	// AMCD05̑䐔


// ControlModuleʃR}h̃eXg
BOOL TestModule( ControlModule *pModule )
{
	if( !pModule->GetVersion() ){
		printf( "Error:%s\n", pModule->Error );
		return( 0 );
	}

	printf( "Ver.%d.%d\r\n", 0x0F & pModule->bVersion >>4, 0x0F & pModule->bVersion );

	printf("Hit any key\n");
	_getch();
	if( !pModule->Blink(3) ){
		printf( "Error:%s\r\n", pModule->Error );
		return( 0 );
	}

	return( TRUE );
}

int main( int argc, char* argv[] )
{
	SC02 sc;
	MCD05 mcd[MODULE_NUM];
	int nVal, i;
	BOOL loop=TRUE;

// Jn
	printf("Open SC02 ");
	if( !sc.Open( CM_MASTER_ID ) ){
		printf( "Error:%s\r\n", sc.Error );
		return( 0 );
	}
	printf("OK\n");

	// MCD05ID0AԂƂȂĂ邱
	for(i=0;i<MODULE_NUM;i++){

		printf("Open MCD05 ID=%d ", i );
		if( !mcd[i].Open( &sc, 0, (BYTE)i )){
			printf( "Error:%s", mcd[i].Error );
			printf("Close SC02\n");
			sc.Close();
			return( 0 );
		}
		printf("OK\n");
	}

// {f[^̑M
// {Iȃf[^̑MDo̓f[^̓NXMCD05̃oϐgp

	MES_StartTimeCount();	// ԌvJn

	nVal= 0;	// f[^̏l

	while(loop){
		printf("%02d:%02d:%02d dt %5.3fms ",
			(int)(MES_dTime_cur/60.0f),(int)MES_dTime_cur%60,(int)(100.0f*MES_dTime_cur)%100, MES_dTime_int * 1000.0f);

		if(_kbhit()){
			switch(_getch()){
            case '7': nVal++; break;
			case '4': if( nVal > 0 ) nVal = -nVal;  break;
			case '1': nVal--; break;
            case '8': nVal+=10; break;
			case '5': nVal = 0;  break;
			case '2': nVal-=10; break;
            case '9': nVal+=100; break;
			case '6': if( nVal < 0 ) nVal = -nVal;  break;
			case '3': nVal-=100; break;
			case 27:
				loop = FALSE;
				nVal = 0;
				break; //GXP[vŏI
			}
		}

		for(i=0;i<MODULE_NUM;i++) mcd[i].OutputData.sPwm = nVal;
		
		MES_GetTimeCount(); // ʐMԌv
		// f[^M
		for(i=0;i<MODULE_NUM-1;i++){
			if(!mcd[i].Exchange(FALSE) ){ // Exchange(FALSE)̎_ł͑MȂD
				printf("Error:%s", mcd[i].Error );
				printf("Close SC02 ");
				sc.Close();
				return(0);
			}
		}
		if(!mcd[i].Exchange(TRUE) ){ // Exchange(TRUE)̎_ł܂Ƃ߂đMD
			printf("Error:%s", mcd[i].Error );
			printf("Close SC02 ");
			sc.Close();
			return(0);
		}

		MES_GetTimeCount(); // ʐMԌv

		for(i=0;i<MODULE_NUM;i++){
			printf(" ID=%d enc %d pwm %d\n", 0x00FF & mcd[i].bID, mcd[i].InputData.lEncoder, mcd[i].OutputData.sPwm );
		}
	
	    Sleep(100);
	}
	

// I
	for(i=0;i<MODULE_NUM;i++){
		printf("Close MCD05 ID=%d ", i );
		if( !mcd[i].Close() ){
			printf("Error:%s", mcd[i].Error );
		}else{
			printf("OK\r\n");
		}
	}

	printf("Close SC02 ");
	sc.Close();
	printf("OK\n");

	return(1);
}

